<template>
    <div>
        <v-list-item-title class="mt-4"
            >Quão satisfeito você ficou com o atendimento do profissional?
        </v-list-item-title>
        <v-list-item-subtitle
            >Escolha de 1 a 5 estrelas para classificar</v-list-item-subtitle
        >
        <v-rating
            background-color="orange lighten-3"
            color="orange"
            @input="changeRating"
            v-model="rating.profissional.rate"
        ></v-rating>
        <div
            v-if="rating.profissional.rate > 0"
            class="m-2 row d-flex flex-row "
        >
            <div
                v-for="(label, key) in getDefaultLabelsColor('labels')"
                v-bind:key="key"
                :class="key % 2 == 0 ? 'text-right' : ''"
                class="col-6 col-md-6 col-sm-6"
            >
                <v-btn
                    style="width: 100%"
                    depressed
                    block
                    @click="checkBtn(label)"
                    :outlined="isChecked(label)"
                    :color="getDefaultLabelsColor('color')"
                >
                    {{ label }}
                </v-btn>
            </div>
        </div>
        <v-col cols="12">
            <v-textarea
                v-if="canSendTextFrom()"
                outlined
                name="input-7-4"
                label="Fique a vontade para nos enviar sua opinião"
            ></v-textarea>
        </v-col>
    </div>
</template>

<script>
export default {
    name: "rating",
    props: {
        area: {
            type: String,
            default: () => "profissional",
        },
    },
    data: () => ({
        isLoading: false,
        sent: false,
        oldRate: 0,
        indicator: {
            value: 0,
            lock: false,
        },
        rating: {
            platform: {
                rate: 0,
                selecteds: [],
            },
            profissional: {
                rate: 0,
                selecteds: [],
            },
        },
        labels: {
            good: {
                profissional: [
                    "ATENCIOSO",
                    "CONFIÁVEL",
                    "PONTUAL",
                    "ÓTIMO TRATAMENTO",
                    "CUSTO E BENEFÍCIO",
                    "QUERO ENVIAR ELOGIO",
                ],
                platform: [
                    "FÁCIL ACESSO",
                    "SIMPLES E OBJETIVO",
                    "NÃO TIVE PROBLEMAS DE VÍDEO E AUDIO",
                    "CONTINUEM ASSIM, ADOREI!",
                    "GOSTEI",
                    "QUERO ENVIAR ELOGIO",
                ],
            },
            bad: {
                profissional: [
                    "FOI MUITO RÁPIDO",
                    "NÃO SENTI CONFIANÇA",
                    "PROFISSIONAL ATRASOU",
                    "NÃO RECEBI UM TRATAMENTO BACANA",
                    "VALOR NÃO COMPATÍVEL",
                    "OUTRO",
                ],
                platform: [
                    "TIVE PROBLEMAS PARA ACESSAR",
                    "FICOU TRAVANDO",
                    "PROBLEMAS DE ÁUDIO",
                    "PROBLEMAS NO VÍDEO",
                    "NÃO SABIA O QUE FAZER",
                    "OUTRO",
                ],
            },
        },
    }),

    methods: {
        changeRating(rate) {
            if (
                (this.oldRate > 2 && rate <= 2) ||
                (this.oldRate < 3 && rate >= 3)
            ) {
                this.rating[this.area].selecteds = [];
            }

            if (rate != this.oldRate) {
                this.oldRate = this.rating[this.area].rate;
            }

            this.$emit("input", { rate: rate, area: this.area });
        },
        isChecked(label) {
            return !(
                this.rating.profissional.selecteds.includes(label) ||
                this.rating.platform.selecteds.includes(label)
            );
        },
        checkBtn(label) {
            let selectedBtns = [...this.rating[this.area].selecteds];
            if (this.rating[this.area].selecteds.includes(label)) {
                let i = selectedBtns.findIndex((item) => item == label);
                selectedBtns.splice(i, 1);
                this.rating[this.area].selecteds = selectedBtns;
            } else {
                selectedBtns.push(label);
                this.rating[this.area].selecteds = selectedBtns;
            }
        },
        getDefaultLabelsColor(type, area = "profissional") {
            switch (type) {
                case "labels":
                    return this.rating[area].rate > 2
                        ? this.labels.good[area]
                        : this.labels.bad[area];
                case "color":
                    return this.rating[area].rate > 2 ? "success" : "error";
                default:
                    return [];
            }
        },
        canSendTextFrom() {
            let allowed = ["QUERO ENVIAR ELOGIO", "OUTRO"];
            let allow = false;
            allowed.forEach((role) => {
                if (this.rating[this.area].selecteds.includes(role)) {
                    allow = true;
                }
            });
            return allow;
        },
    },
};
</script>
